+++
title = "Milkymist One"
weight = 1
template = "page.html"
+++


<a href="/images/m1_large.jpg"><img src="/images/m1.jpg"></a>

The Milkymist One is an experimental hardware appliance for live video effects.

The small 172x145x45mm device creates visualizations similar to those generated by the <a href="http://www.geisswerks.com/milkdrop/" target="_blank" rel="noopener noreferrer">MilkDrop</a> software, and enables you to mix them with live footage from a camera and interact using MIDI and DMX controllers.

The Milkymist One is programmable and customizable at many different levels.

The simplest way one can use a Milkymist One is by affecting MIDI controls to the existing snippets of code (called "patches") that create the effects. The Milkymist One ships with dozens of pre-existing patches.

Creating new patches can be done with a simple programming language based on the <a href="http://www.milkdrop.co.uk/guide.htm" target="_blank" rel="noopener noreferrer">MilkDrop preset format</a>. The Milkymist One device comes with a built-in editor.

Under the hood, the Milkymist One is like a mini-computer running our Flickernoise video synthesis software.

But we did not stop at open source <em>software</em>. As a matter of fact, when this project started in August 2007, one of the goals was to open up <em>chip design</em>. Inside the device, which was launched in September 2011, the Flickernoise software is actually running on an open source CPU part of our own system-on-chip.


## Detailed specifications

<img src="/images/m1_board.jpg">

- Multi-standard video input (PAL/SECAM/NTSC)
- Two DMX512 (RS485) ports
- MIDI IN and MIDI OUT ports
- VGA output, 24bpp
- AC97 audio
- XC6SLX45 Spartan-6 FPGA supporting the open source Milkymist SoC
- 128MB 32-bit DDR333 SDRAM
- 32MB parallel flash
- 10/100 Ethernet
- Memory card
- Two 12Mbps USB host connectors
- RC-5 compatible infrared receiver
- RS232 debug port

## Press

- Create Digital Motion (10/02/2012): <a href="http://createdigitalmotion.com/2012/02/milkymist-is-digital-visual-synthesizer-and-processor-built-on-sophisticated-open-source-hardware/">Milkymist is Digital Visual Synthesizer and Processor, Built as Sophisticated Open Source Hardware</a>
- MikroBitti (03/2012): <a href="http://www.mbnet.fi/artikkeli/lehti/avointa_vj_rautaa_3_2012">Milkymist One -visualisaattori: Avointa vj-rautaa</a> [FI]
- Make Magazine (30/09/2011): <a href="http://blog.makezine.com/2011/09/30/milkymist-one-an-open-source-vj-console-goes-on-sale/">Milkymist One, an Open Source VJ Console, Goes on Sale</a>
- The Register (28/09/2011): <a href="http://www.theregister.co.uk/2011/09/28/milkymist/print.html">Open-source hardware group puts out vid system-on-a-chip</a>
- Theory&amp;Practice (22/09/2011): <a href="http://theoryandpractice.ru/seminars/19402-videosintezator-s-otkrytym-kodom-milkymist-one-22-9">Видеосинтезатор с открытым кодом Milkymist One</a> [RU]
- ETN (17/05/2011): <a href="http://www.etn.se/index.php?option=com_content&view=article&id=53785">Videoeffekter i öppen hårdvara söker partners</a> [SE]
- Linux-Magazin (28/01/2011): <a href="http://www.linux-magazin.de/NEWS/VJ-System-Milkymist-als-Entwicklerboard-erhaeltlich">VJ-System Milkymist als Entwicklerboard erhältlich</a> [DE]
- Create Digital Motion (16/08/2010): <a href="http://createdigitalmotion.com/2010/08/milkymist-one-all-in-one-open-source-vj-workstation/">Milkymist One, All-in-One Open Source VJ Workstation</a>
- Linux-Magazin (29/12/2009): <a href="http://www.linux-magazin.de/NEWS/26c3-Bewegtbildgenerator-Milkymist-bald-mit-Ethernet-und-USB">26c3: Bewegtbildgenerator Milkymist bald mit Ethernet und USB</a> [DE]


## Buy a Milkymist One

We are no longer selling Milkymist One. If you want one, you can ask about buying a second-hand unit on the <a href="https://ssl.serverraum.org/lists/listinfo/devel/listinfo.cgi/devel-milkymist.org">mailing list</a>, or take the open source design files and manufacture it yourself.

## Video

<iframe width="420" height="315" src="http://www.youtube-nocookie.com/embed/0k080nzA_z4" frameborder="0" allowfullscreen></iframe>


## Screenshots

<a href="/fnscreenshots/pdf.png"><img src="/fnscreenshots/pdf_small.jpg"></a>
<a href="/fnscreenshots/darkblue.png"><img src="/fnscreenshots/darkblue_small.jpg"></a>
<a href="/fnscreenshots/sailing1.png"><img src="/fnscreenshots/sailing1_small.jpg"></a>
<a href="/fnscreenshots/sailing2.png"><img src="/fnscreenshots/sailing2_small.jpg"></a>
<a href="/fnscreenshots/sailing3.png"><img src="/fnscreenshots/sailing3_small.jpg"></a>
<a href="/fnscreenshots/sailing4.png"><img src="/fnscreenshots/sailing4_small.jpg"></a>
<a href="/fnscreenshots/sailing5.png"><img src="/fnscreenshots/sailing5_small.jpg"></a>
<a href="/fnscreenshots/starballet1.png"><img src="/fnscreenshots/starballet1_small.jpg"></a>
<a href="/fnscreenshots/starballet2.png"><img src="/fnscreenshots/starballet2_small.jpg"></a>
<a href="/fnscreenshots/starballet3.png"><img src="/fnscreenshots/starballet3_small.jpg"></a>
<a href="/fnscreenshots/starballet4.png"><img src="/fnscreenshots/starballet4_small.jpg"></a>
<a href="/fnscreenshots/starballet5.png"><img src="/fnscreenshots/starballet5_small.jpg"></a>
<a href="/fnscreenshots/starballet6.png"><img src="/fnscreenshots/starballet6_small.jpg"></a>
<a href="/fnscreenshots/starballet7.png"><img src="/fnscreenshots/starballet7_small.jpg"></a>
<a href="/fnscreenshots/starpainter1.png"><img src="/fnscreenshots/starpainter1_small.jpg"></a>
<a href="/fnscreenshots/starpainter2.png"><img src="/fnscreenshots/starpainter2_small.jpg"></a>
<a href="/fnscreenshots/starpainter3.png"><img src="/fnscreenshots/starpainter3_small.jpg"></a>
<a href="/fnscreenshots/plasmastreams.png"><img src="/fnscreenshots/plasmastreams_small.jpg"></a>
<a href="/fnscreenshots/pshroomery.png"><img src="/fnscreenshots/pshroomery_small.jpg"></a>
<a href="/fnscreenshots/pshroomery2.png"><img src="/fnscreenshots/pshroomery2_small.jpg"></a>
<a href="/fnscreenshots/pshroomery3.png"><img src="/fnscreenshots/pshroomery3_small.jpg"></a>
<a href="/fnscreenshots/pshroomery4.png"><img src="/fnscreenshots/pshroomery4_small.jpg"></a>
<a href="/fnscreenshots/eerieberi.png"><img src="/fnscreenshots/eerieberi_small.jpg"></a>
<a href="/fnscreenshots/pdb1.png"><img src="/fnscreenshots/pdb1_small.jpg"></a>
<a href="/fnscreenshots/pdb2.png"><img src="/fnscreenshots/pdb2_small.jpg"></a>
<a href="/fnscreenshots/kalei.png"><img src="/fnscreenshots/kalei_small.jpg"></a>
<a href="/fnscreenshots/torridtales3.png"><img src="/fnscreenshots/torridtales3_small.jpg"></a>
<a href="/fnscreenshots/torridtales.png"><img src="/fnscreenshots/torridtales_small.jpg"></a>
<a href="/fnscreenshots/burningdisc.png"><img src="/fnscreenshots/burningdisc_small.jpg"></a>
<a href="/fnscreenshots/burningdisc2.png"><img src="/fnscreenshots/burningdisc2_small.jpg"></a>
<a href="/fnscreenshots/burningpanel.png"><img src="/fnscreenshots/burningpanel_small.jpg"></a>
<a href="/fnscreenshots/crazyface.png"><img src="/fnscreenshots/crazyface_small.jpg"></a>
<a href="/fnscreenshots/crazyface2.png"><img src="/fnscreenshots/crazyface2_small.jpg"></a>
<a href="/fnscreenshots/mateball.png"><img src="/fnscreenshots/mateball_small.jpg"></a>
<a href="/fnscreenshots/pyramids.png"><img src="/fnscreenshots/pyramids_small.jpg"></a>
<a href="/fnscreenshots/madness.png"><img src="/fnscreenshots/madness_small.jpg"></a>
<a href="/fnscreenshots/explosiveminds.png"><img src="/fnscreenshots/explosiveminds_small.jpg"></a>
<a href="/fnscreenshots/torridtales2.png"><img src="/fnscreenshots/torridtales2_small.jpg"></a>
<a href="/fnscreenshots/8bitstarfield.png"><img src="/fnscreenshots/8bitstarfield_small.jpg"></a>
<a href="/fnscreenshots/airs.png"><img src="/fnscreenshots/airs_small.jpg"></a>
<a href="/fnscreenshots/aqualung.png"><img src="/fnscreenshots/aqualung_small.jpg"></a>
<a href="/fnscreenshots/balkacid.png"><img src="/fnscreenshots/balkacid_small.jpg"></a>
<a href="/fnscreenshots/cloudedbottle.png"><img src="/fnscreenshots/cloudedbottle_small.jpg"></a>
<a href="/fnscreenshots/cosmicechoes.png"><img src="/fnscreenshots/cosmicechoes_small.jpg"></a>
<a href="/fnscreenshots/digitalflame.png"><img src="/fnscreenshots/digitalflame_small.jpg"></a>
<a href="/fnscreenshots/drunkenboat.png"><img src="/fnscreenshots/drunkenboat_small.jpg"></a>
<a href="/fnscreenshots/eerieberi2.png"><img src="/fnscreenshots/eerieberi2_small.jpg"></a>
<a href="/fnscreenshots/interwoven.png"><img src="/fnscreenshots/interwoven_small.jpg"></a>
<a href="/fnscreenshots/madness2.png"><img src="/fnscreenshots/madness2_small.jpg"></a>
<a href="/fnscreenshots/shaking.png"><img src="/fnscreenshots/shaking_small.jpg"></a>
<a href="/fnscreenshots/ssmatrix.png"><img src="/fnscreenshots/ssmatrix_small.jpg"></a>
<a href="/fnscreenshots/patcheditor2.png"><img src="/fnscreenshots/patcheditor2_small.jpg"></a>
<a href="/fnscreenshots/glass.png"><img src="/fnscreenshots/glass_small.jpg"></a>
<a href="/fnscreenshots/glass2.png"><img src="/fnscreenshots/glass2_small.jpg"></a>
<a href="/fnscreenshots/face.png"><img src="/fnscreenshots/face_small.jpg"></a>


## Milkymist SoC


<img src="/images/jtagserialb.jpg">

<img src="/images/jtagserialt.jpg">

The Milkymist SoC is at the core of the Milkymist One, implemented in the Spartan-6 FPGA.

The Milkymist <a href="http://en.wikipedia.org/wiki/System-on-chip">system-on-chip</a> uses the <a href="http://www.latticesemi.com/mico32">LatticeMico32</a> (LM32) core as a general purpose processor. It is a RISC 32-bit big endian CPU without a memory management unit (MMU). It is supported by the GCC compiler and can run <a href="http://www.rtems.com">RTEMS</a> and <a href="http://www.github.com/m-labs/linux-milkymist">uClinux</a>. There is also an <a href="https://github.com/m-labs/llvm-lm32">experimental back-end for LLVM</a> targeting this microprocessor.

The LM32 microprocessor is assisted by a texture mapping unit and a programmable floating point VLIW coprocessor which are used by the Flickernoise video synthesis software. It is also surrounded by various peripheral cores to support every I/O device of the Milkymist One. The system-on-chip interconnect uses three bridged buses and mixes the Wishbone protocol with two custom protocols used for configuration registers and high performance DMA with the SDRAM.

The architecture of the Milkymist system-on-chip is largely documented in the project founder's <a href="/thesis/thesis.pdf" target="_blank" rel="noopener noreferrer">Master thesis report</a>. Most components of the system-on-chip, except the LatticeMico32 core, were custom developed and placed under the GNU GPL license.

The QEMU emulator can be used to run and debug Milkymist SoC binaries on another computer.

The SoC source distribution includes software libraries, the BIOS and the demonstration firmware, as well as test benches, LaTeX source for the documentation, build scripts, etc. The repository is hosted by GitHub and is available <a href="http://github.com/m-labs/milkymist">here</a>.

Milkymist SoC is phased out in favor of the more powerful [MiSoC](@/gateware/migen.md).


## Flickernoise

Flickernoise is the video synthesis application developed for the Milkymist One and the Milkymist SoC. It renders hardware-accelerated visual effects comparable (and, to some extent, compatible) with those of <a href="http://www.nullsoft.com/free/milkdrop">MilkDrop</a> 1.x, the popular audio visualization plug-in for Winamp.

Flickernoise allows the creation of visual patches and their connection with all the interfaces that the Milkymist One provides thanks to a built-in graphical user interface. Let the visuals react to sound and MIDI events, connect a camera and create live phantasmagoric images of yourself...

Flickernoise uses:

- The <a href="http://www.rtems.org">RTEMS</a> real-time operating system.
- The <a href="http://www.yaffs.org">YAFFS</a> flash filesystem (modified version <a href="http://www.github.com/m-labs/rtems-yaffs2">here</a>).
- The <a href="http://www.libpng.org">libpng</a>, <a href="http://www.ijg.org">libjpeg</a>, <a href="http://www.ijg.org">openjpeg</a> and <a href="http://jbig2dec.sourceforge.net/">jbig2dec</a> image decompression libraries.
- The <a href="http://www.freetype.org">freetype</a> font rendering system.
- The <a href="http://www.mupdf.com">MuPDF</a> library for the online help system.
- <a href="http://www.github.com/m-labs/mtk">MTK</a>, a modified version of the <a href="http://www.genode-labs.com/products/fpga-graphics">Genode FX</a> embedded GUI toolkit, which provides all the elements for common user interaction (windows, buttons, etc.).
- <a href="http://www.github.com/m-labs/liboscparse">liboscparse</a>, a variant of <a href="http://liblo.sourceforge.net/">liblo</a>, for <a href="http://www.opensoundcontrol.org">OpenSoundControl</a> communications.


## Credits

Thanks to the many people who made Milkymist One possible - in no particular order:

Sebastien Bourdeauducq (founder), Michael Walle (software), Adam Wang (production engineering), Uwe Bonnes, Werner Almesberger, Jon Phillips (evangelist), Yi Zhang (operations), Christophe Devine, Don Miller, John Lejeune, Wim Vandeputte, Xiangfu Liu (software), Wolfgang Spraul, Joachim roh Steiger (mechanical), Yanjun Luo (jtag-serial design), Lars-Peter Clausen, Cristian Paul (early adopter), Christopher Adams (logo design), Christiaan Virant (advice), Takeshi Matsuya (Linux port), Akuei Chen (smt), Anson Lin (layout), Vera Cheng (layout), Terry (pcb), Nick Chen (remote control), Eva Su (sourcing), Sean Xiao (sourcing), Elisha Tseng (xilinx fae), Henry de Beauchesne, Philip Sheu (nor flash), Arno Lin (vga connector), Sun Hung Kuang (jtag-serial smt), Aaron Lee (usb connector), Ruby Su (sourcing), Yunchao Xie (ccd camera), Xiaochun Lu (power supply), Cailin Dai (box design), Mr. Zhang (box making), Xianke Zhang (eva), Xin Cai (label printing), Ting Jiang (sticker making), Xiaopeng Li (silicone keyboard), Mr. Ba (audio, video cables), Dehua Xiao (ethernet cable), Miss Zhao (usb cable), Shen Chun Yi (package pickup Taipei)...

Plus countless workers at dozens of suppliers and many more who created the free technology we were able to build upon.
